Git 2.19
[git/git.git] / t / test-lib-functions.sh
CommitLineData
c74c7203
JN
1# Library of functions shared by all tests scripts, included by
2# test-lib.sh.
12a29b1a
TR
3#
4# Copyright (c) 2005 Junio C Hamano
5#
6# This program is free software: you can redistribute it and/or modify
7# it under the terms of the GNU General Public License as published by
8# the Free Software Foundation, either version 2 of the License, or
9# (at your option) any later version.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
16# You should have received a copy of the GNU General Public License
17# along with this program. If not, see http://www.gnu.org/licenses/ .
18
19# The semantics of the editor variables are that of invoking
20# sh -c "$EDITOR \"$@\"" files ...
21#
22# If our trash directory contains shell metacharacters, they will be
23# interpreted if we just set $EDITOR directly, so do a little dance with
24# environment variables to work around this.
25#
26# In particular, quoting isn't enough, as the path may contain the same quote
27# that we're using.
28test_set_editor () {
29 FAKE_EDITOR="$1"
30 export FAKE_EDITOR
31 EDITOR='"$FAKE_EDITOR"'
32 export EDITOR
33}
34
5d9fc888
TG
35test_set_index_version () {
36 GIT_INDEX_VERSION="$1"
37 export GIT_INDEX_VERSION
38}
39
12a29b1a
TR
40test_decode_color () {
41 awk '
42 function name(n) {
43 if (n == 0) return "RESET";
44 if (n == 1) return "BOLD";
097b681b 45 if (n == 7) return "REVERSE";
12a29b1a
TR
46 if (n == 30) return "BLACK";
47 if (n == 31) return "RED";
48 if (n == 32) return "GREEN";
49 if (n == 33) return "YELLOW";
50 if (n == 34) return "BLUE";
51 if (n == 35) return "MAGENTA";
52 if (n == 36) return "CYAN";
53 if (n == 37) return "WHITE";
54 if (n == 40) return "BLACK";
55 if (n == 41) return "BRED";
56 if (n == 42) return "BGREEN";
57 if (n == 43) return "BYELLOW";
58 if (n == 44) return "BBLUE";
59 if (n == 45) return "BMAGENTA";
60 if (n == 46) return "BCYAN";
61 if (n == 47) return "BWHITE";
62 }
63 {
64 while (match($0, /\033\[[0-9;]*m/) != 0) {
65 printf "%s<", substr($0, 1, RSTART-1);
66 codes = substr($0, RSTART+2, RLENGTH-3);
67 if (length(codes) == 0)
68 printf "%s", name(0)
69 else {
70 n = split(codes, ary, ";");
71 sep = "";
72 for (i = 1; i <= n; i++) {
73 printf "%s%s", sep, name(ary[i]);
74 sep = ";"
75 }
76 }
77 printf ">";
78 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
79 }
80 print
81 }
82 '
83}
84
b249e39f
JH
85lf_to_nul () {
86 perl -pe 'y/\012/\000/'
87}
88
12a29b1a 89nul_to_q () {
94221d22 90 perl -pe 'y/\000/Q/'
12a29b1a
TR
91}
92
93q_to_nul () {
94221d22 94 perl -pe 'y/Q/\000/'
12a29b1a
TR
95}
96
97q_to_cr () {
98 tr Q '\015'
99}
100
101q_to_tab () {
102 tr Q '\011'
103}
104
250b3c6c
JH
105qz_to_tab_space () {
106 tr QZ '\011\040'
12a29b1a
TR
107}
108
109append_cr () {
110 sed -e 's/$/Q/' | tr Q '\015'
111}
112
113remove_cr () {
114 tr '\015' Q | sed -e 's/Q$//'
115}
116
117# In some bourne shell implementations, the "unset" builtin returns
118# nonzero status when a variable to be unset was not set in the first
119# place.
120#
121# Use sane_unset when that should not be considered an error.
122
123sane_unset () {
124 unset "$@"
125 return 0
126}
127
128test_tick () {
129 if test -z "${test_tick+set}"
130 then
131 test_tick=1112911993
132 else
133 test_tick=$(($test_tick + 60))
134 fi
135 GIT_COMMITTER_DATE="$test_tick -0700"
136 GIT_AUTHOR_DATE="$test_tick -0700"
137 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
138}
139
59210dd5 140# Stop execution and start a shell. This is useful for debugging tests.
12a29b1a
TR
141#
142# Be sure to remove all invocations of this command before submitting.
143
144test_pause () {
59210dd5 145 "$SHELL_PATH" <&6 >&5 2>&7
12a29b1a
TR
146}
147
84243646
EN
148# Wrap git with a debugger. Adding this to a command can make it easier
149# to understand what is going on in a failing test.
6a94088c 150#
84243646
EN
151# Examples:
152# debug git checkout master
153# debug --debugger=nemiver git $ARGS
154# debug -d "valgrind --tool=memcheck --track-origins=yes" git $ARGS
6a94088c 155debug () {
84243646
EN
156 case "$1" in
157 -d)
158 GIT_DEBUGGER="$2" &&
159 shift 2
160 ;;
161 --debugger=*)
162 GIT_DEBUGGER="${1#*=}" &&
163 shift 1
164 ;;
165 *)
166 GIT_DEBUGGER=1
167 ;;
168 esac &&
169 GIT_DEBUGGER="${GIT_DEBUGGER}" "$@" <&6 >&5 2>&7
6a94088c
JS
170}
171
6f94351b
SB
172# Call test_commit with the arguments
173# [-C <directory>] <message> [<file> [<contents> [<tag>]]]"
12a29b1a
TR
174#
175# This will commit a file with the given contents and the given commit
4c994194 176# message, and tag the resulting commit with the given tag name.
12a29b1a 177#
4c994194 178# <file>, <contents>, and <tag> all default to <message>.
6f94351b
SB
179#
180# If the first argument is "-C", the second argument is used as a path for
181# the git invocations.
12a29b1a
TR
182
183test_commit () {
9a0231b3 184 notick= &&
5ed75e2a 185 signoff= &&
6f94351b 186 indir= &&
5ed75e2a
MV
187 while test $# != 0
188 do
189 case "$1" in
190 --notick)
191 notick=yes
192 ;;
193 --signoff)
194 signoff="$1"
195 ;;
6f94351b
SB
196 -C)
197 indir="$2"
198 shift
199 ;;
5ed75e2a
MV
200 *)
201 break
202 ;;
203 esac
9a0231b3 204 shift
5ed75e2a 205 done &&
6f94351b 206 indir=${indir:+"$indir"/} &&
9a0231b3 207 file=${2:-"$1.t"} &&
6f94351b
SB
208 echo "${3-$1}" > "$indir$file" &&
209 git ${indir:+ -C "$indir"} add "$file" &&
9a0231b3
JH
210 if test -z "$notick"
211 then
212 test_tick
213 fi &&
6f94351b
SB
214 git ${indir:+ -C "$indir"} commit $signoff -m "$1" &&
215 git ${indir:+ -C "$indir"} tag "${4:-$1}"
12a29b1a
TR
216}
217
218# Call test_merge with the arguments "<message> <commit>", where <commit>
219# can be a tag pointing to the commit-to-merge.
220
221test_merge () {
222 test_tick &&
223 git merge -m "$1" "$2" &&
224 git tag "$1"
225}
226
227# This function helps systems where core.filemode=false is set.
228# Use it instead of plain 'chmod +x' to set or unset the executable bit
229# of a file in the working directory and add it to the index.
230
231test_chmod () {
232 chmod "$@" &&
233 git update-index --add "--chmod=$@"
234}
235
73de1c93
CC
236# Get the modebits from a file.
237test_modebits () {
238 ls -l "$1" | sed -e 's|^\(..........\).*|\1|'
239}
240
12a29b1a
TR
241# Unset a configuration variable, but don't fail if it doesn't exist.
242test_unconfig () {
5fafc07f
JK
243 config_dir=
244 if test "$1" = -C
245 then
246 shift
247 config_dir=$1
248 shift
249 fi
250 git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
12a29b1a
TR
251 config_status=$?
252 case "$config_status" in
253 5) # ok, nothing to unset
254 config_status=0
255 ;;
256 esac
257 return $config_status
258}
259
260# Set git config, automatically unsetting it after the test is over.
261test_config () {
5fafc07f
JK
262 config_dir=
263 if test "$1" = -C
264 then
265 shift
266 config_dir=$1
267 shift
268 fi
269 test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
270 git ${config_dir:+-C "$config_dir"} config "$@"
12a29b1a
TR
271}
272
273test_config_global () {
274 test_when_finished "test_unconfig --global '$1'" &&
275 git config --global "$@"
276}
277
278write_script () {
279 {
280 echo "#!${2-"$SHELL_PATH"}" &&
281 cat
282 } >"$1" &&
283 chmod +x "$1"
284}
285
286# Use test_set_prereq to tell that a particular prerequisite is available.
287# The prerequisite can later be checked for in two ways:
288#
289# - Explicitly using test_have_prereq.
290#
291# - Implicitly by specifying the prerequisite tag in the calls to
292# test_expect_{success,failure,code}.
293#
294# The single parameter is the prerequisite tag (a simple word, in all
295# capital letters by convention).
296
7d0ee47c
JS
297test_unset_prereq () {
298 ! test_have_prereq "$1" ||
299 satisfied_prereq="${satisfied_prereq% $1 *} ${satisfied_prereq#* $1 }"
300}
301
12a29b1a 302test_set_prereq () {
7d0ee47c
JS
303 case "$1" in
304 !*)
305 test_unset_prereq "${1#!}"
306 ;;
307 *)
308 satisfied_prereq="$satisfied_prereq$1 "
309 ;;
310 esac
12a29b1a 311}
f3cfc3b2 312satisfied_prereq=" "
04083f27
JH
313lazily_testable_prereq= lazily_tested_prereq=
314
315# Usage: test_lazy_prereq PREREQ 'script'
316test_lazy_prereq () {
317 lazily_testable_prereq="$lazily_testable_prereq$1 "
318 eval test_prereq_lazily_$1=\$2
319}
320
321test_run_lazy_prereq_ () {
322 script='
323mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
324(
325 cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
326)'
327 say >&3 "checking prerequisite: $1"
328 say >&3 "$script"
329 test_eval_ "$script"
330 eval_ret=$?
331 rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
332 if test "$eval_ret" = 0; then
333 say >&3 "prerequisite $1 ok"
334 else
335 say >&3 "prerequisite $1 not satisfied"
336 fi
337 return $eval_ret
338}
12a29b1a
TR
339
340test_have_prereq () {
341 # prerequisites can be concatenated with ','
342 save_IFS=$IFS
343 IFS=,
344 set -- $*
345 IFS=$save_IFS
346
347 total_prereq=0
348 ok_prereq=0
349 missing_prereq=
350
351 for prerequisite
352 do
bdccd3c1
JK
353 case "$prerequisite" in
354 !*)
355 negative_prereq=t
356 prerequisite=${prerequisite#!}
357 ;;
358 *)
359 negative_prereq=
360 esac
361
04083f27
JH
362 case " $lazily_tested_prereq " in
363 *" $prerequisite "*)
364 ;;
365 *)
366 case " $lazily_testable_prereq " in
367 *" $prerequisite "*)
368 eval "script=\$test_prereq_lazily_$prerequisite" &&
369 if test_run_lazy_prereq_ "$prerequisite" "$script"
370 then
371 test_set_prereq $prerequisite
372 fi
373 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
374 esac
375 ;;
376 esac
377
12a29b1a 378 total_prereq=$(($total_prereq + 1))
f3cfc3b2 379 case "$satisfied_prereq" in
12a29b1a 380 *" $prerequisite "*)
bdccd3c1
JK
381 satisfied_this_prereq=t
382 ;;
383 *)
384 satisfied_this_prereq=
385 esac
386
387 case "$satisfied_this_prereq,$negative_prereq" in
388 t,|,t)
12a29b1a
TR
389 ok_prereq=$(($ok_prereq + 1))
390 ;;
391 *)
bdccd3c1
JK
392 # Keep a list of missing prerequisites; restore
393 # the negative marker if necessary.
394 prerequisite=${negative_prereq:+!}$prerequisite
12a29b1a
TR
395 if test -z "$missing_prereq"
396 then
397 missing_prereq=$prerequisite
398 else
399 missing_prereq="$prerequisite,$missing_prereq"
400 fi
401 esac
402 done
403
404 test $total_prereq = $ok_prereq
405}
406
407test_declared_prereq () {
408 case ",$test_prereq," in
409 *,$1,*)
410 return 0
411 ;;
412 esac
413 return 1
414}
415
d93d5d51
JH
416test_verify_prereq () {
417 test -z "$test_prereq" ||
418 expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
419 error "bug in the test script: '$test_prereq' does not look like a prereq"
420}
421
12a29b1a 422test_expect_failure () {
ae75342c 423 test_start_
12a29b1a
TR
424 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
425 test "$#" = 2 ||
426 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
d93d5d51 427 test_verify_prereq
12a29b1a
TR
428 export test_prereq
429 if ! test_skip "$@"
430 then
431 say >&3 "checking known breakage: $2"
432 if test_run_ "$2" expecting_failure
433 then
434 test_known_broken_ok_ "$1"
435 else
436 test_known_broken_failure_ "$1"
437 fi
438 fi
ae75342c 439 test_finish_
12a29b1a
TR
440}
441
442test_expect_success () {
ae75342c 443 test_start_
12a29b1a
TR
444 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
445 test "$#" = 2 ||
446 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
d93d5d51 447 test_verify_prereq
12a29b1a
TR
448 export test_prereq
449 if ! test_skip "$@"
450 then
451 say >&3 "expecting success: $2"
452 if test_run_ "$2"
453 then
454 test_ok_ "$1"
455 else
456 test_failure_ "$@"
457 fi
458 fi
ae75342c 459 test_finish_
12a29b1a
TR
460}
461
462# test_external runs external test scripts that provide continuous
463# test output about their progress, and succeeds/fails on
464# zero/non-zero exit code. It outputs the test output on stdout even
465# in non-verbose mode, and announces the external script with "# run
466# <n>: ..." before running it. When providing relative paths, keep in
467# mind that all scripts run in "trash directory".
468# Usage: test_external description command arguments...
469# Example: test_external 'Perl API' perl ../path/to/test.pl
470test_external () {
471 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
472 test "$#" = 3 ||
473 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
474 descr="$1"
475 shift
d93d5d51 476 test_verify_prereq
12a29b1a
TR
477 export test_prereq
478 if ! test_skip "$descr" "$@"
479 then
480 # Announce the script to reduce confusion about the
481 # test output that follows.
482 say_color "" "# run $test_count: $descr ($*)"
483 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
484 # to be able to use them in script
485 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
486 # Run command; redirect its stderr to &4 as in
487 # test_run_, but keep its stdout on our stdout even in
488 # non-verbose mode.
489 "$@" 2>&4
9e8f8dea 490 if test "$?" = 0
12a29b1a
TR
491 then
492 if test $test_external_has_tap -eq 0; then
493 test_ok_ "$descr"
494 else
495 say_color "" "# test_external test $descr was ok"
496 test_success=$(($test_success + 1))
497 fi
498 else
499 if test $test_external_has_tap -eq 0; then
500 test_failure_ "$descr" "$@"
501 else
502 say_color error "# test_external test $descr failed: $@"
503 test_failure=$(($test_failure + 1))
504 fi
505 fi
506 fi
507}
508
509# Like test_external, but in addition tests that the command generated
510# no output on stderr.
511test_external_without_stderr () {
512 # The temporary file has no (and must have no) security
513 # implications.
514 tmp=${TMPDIR:-/tmp}
515 stderr="$tmp/git-external-stderr.$$.tmp"
516 test_external "$@" 4> "$stderr"
9e8f8dea 517 test -f "$stderr" || error "Internal error: $stderr disappeared."
12a29b1a
TR
518 descr="no stderr: $1"
519 shift
520 say >&3 "# expecting no stderr from previous command"
9e8f8dea
DA
521 if test ! -s "$stderr"
522 then
12a29b1a
TR
523 rm "$stderr"
524
525 if test $test_external_has_tap -eq 0; then
526 test_ok_ "$descr"
527 else
528 say_color "" "# test_external_without_stderr test $descr was ok"
529 test_success=$(($test_success + 1))
530 fi
531 else
9e8f8dea
DA
532 if test "$verbose" = t
533 then
534 output=$(echo; echo "# Stderr is:"; cat "$stderr")
12a29b1a
TR
535 else
536 output=
537 fi
538 # rm first in case test_failure exits.
539 rm "$stderr"
540 if test $test_external_has_tap -eq 0; then
541 test_failure_ "$descr" "$@" "$output"
542 else
543 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
544 test_failure=$(($test_failure + 1))
545 fi
546 fi
547}
548
549# debugging-friendly alternatives to "test [-f|-d|-e]"
550# The commands test the existence or non-existence of $1. $2 can be
551# given to provide a more precise diagnosis.
552test_path_is_file () {
9e8f8dea 553 if ! test -f "$1"
12a29b1a 554 then
de248e92 555 echo "File $1 doesn't exist. $2"
12a29b1a
TR
556 false
557 fi
558}
559
560test_path_is_dir () {
9e8f8dea 561 if ! test -d "$1"
12a29b1a 562 then
de248e92 563 echo "Directory $1 doesn't exist. $2"
12a29b1a
TR
564 false
565 fi
566}
567
7e9055bb
EN
568test_path_exists () {
569 if ! test -e "$1"
570 then
571 echo "Path $1 doesn't exist. $2"
572 false
573 fi
574}
575
0be7d9b7
JL
576# Check if the directory exists and is empty as expected, barf otherwise.
577test_dir_is_empty () {
578 test_path_is_dir "$1" &&
579 if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
580 then
581 echo "Directory '$1' is not empty, it contains:"
582 ls -la "$1"
583 return 1
584 fi
585}
586
12a29b1a 587test_path_is_missing () {
9e8f8dea 588 if test -e "$1"
12a29b1a
TR
589 then
590 echo "Path exists:"
591 ls -ld "$1"
9e8f8dea
DA
592 if test $# -ge 1
593 then
12a29b1a
TR
594 echo "$*"
595 fi
596 false
597 fi
598}
599
600# test_line_count checks that a file has the number of lines it
601# ought to. For example:
602#
603# test_expect_success 'produce exactly one line of output' '
604# do something >output &&
605# test_line_count = 1 output
606# '
607#
608# is like "test $(wc -l <output) = 1" except that it passes the
609# output through when the number of lines is wrong.
610
611test_line_count () {
612 if test $# != 3
613 then
614 error "bug in the test script: not 3 parameters to test_line_count"
615 elif ! test $(wc -l <"$3") "$1" "$2"
616 then
617 echo "test_line_count: line count for $3 !$1 $2"
618 cat "$3"
619 return 1
620 fi
621}
622
bbfe5302
LS
623# Returns success if a comma separated string of keywords ($1) contains a
624# given keyword ($2).
625# Examples:
626# `list_contains "foo,bar" bar` returns 0
627# `list_contains "foo" bar` returns 1
628
629list_contains () {
630 case ",$1," in
631 *,$2,*)
632 return 0
633 ;;
634 esac
635 return 1
636}
637
12a29b1a
TR
638# This is not among top-level (test_expect_success | test_expect_failure)
639# but is a prefix that can be used in the test script, like:
640#
641# test_expect_success 'complain and die' '
642# do something &&
643# do something else &&
644# test_must_fail git checkout ../outerspace
645# '
646#
647# Writing this as "! git checkout ../outerspace" is wrong, because
648# the failure could be due to a segv. We want a controlled failure.
12e31a6b
SG
649#
650# Accepts the following options:
651#
652# ok=<signal-name>[,<...>]:
653# Don't treat an exit caused by the given signal as error.
654# Multiple signals can be specified as a comma separated list.
655# Currently recognized signal names are: sigpipe, success.
656# (Don't use 'success', use 'test_might_fail' instead.)
12a29b1a
TR
657
658test_must_fail () {
bbfe5302
LS
659 case "$1" in
660 ok=*)
661 _test_ok=${1#ok=}
662 shift
663 ;;
664 *)
665 _test_ok=
666 ;;
667 esac
a5bf824f 668 "$@" 2>&7
12a29b1a 669 exit_code=$?
bbfe5302
LS
670 if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
671 then
03aa3783 672 echo >&4 "test_must_fail: command succeeded: $*"
12a29b1a 673 return 1
2472448c 674 elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
8bf4becf
LS
675 then
676 return 0
bbfe5302
LS
677 elif test $exit_code -gt 129 && test $exit_code -le 192
678 then
03aa3783 679 echo >&4 "test_must_fail: died by signal $(($exit_code - 128)): $*"
12a29b1a 680 return 1
bbfe5302
LS
681 elif test $exit_code -eq 127
682 then
03aa3783 683 echo >&4 "test_must_fail: command not found: $*"
12a29b1a 684 return 1
bbfe5302
LS
685 elif test $exit_code -eq 126
686 then
03aa3783 687 echo >&4 "test_must_fail: valgrind error: $*"
eeb69131 688 return 1
12a29b1a
TR
689 fi
690 return 0
a5bf824f 691} 7>&2 2>&4
12a29b1a
TR
692
693# Similar to test_must_fail, but tolerates success, too. This is
694# meant to be used in contexts like:
695#
696# test_expect_success 'some command works without configuration' '
697# test_might_fail git config --unset all.configuration &&
698# do something
699# '
700#
701# Writing "git config --unset all.configuration || :" would be wrong,
702# because we want to notice if it fails due to segv.
12e31a6b
SG
703#
704# Accepts the same options as test_must_fail.
12a29b1a
TR
705
706test_might_fail () {
a5bf824f
SG
707 test_must_fail ok=success "$@" 2>&7
708} 7>&2 2>&4
12a29b1a
TR
709
710# Similar to test_must_fail and test_might_fail, but check that a
711# given command exited with a given exit code. Meant to be used as:
712#
713# test_expect_success 'Merge with d/f conflicts' '
714# test_expect_code 1 git merge "merge msg" B master
715# '
716
717test_expect_code () {
718 want_code=$1
719 shift
a5bf824f 720 "$@" 2>&7
12a29b1a
TR
721 exit_code=$?
722 if test $exit_code = $want_code
723 then
724 return 0
725 fi
726
03aa3783 727 echo >&4 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
12a29b1a 728 return 1
a5bf824f 729} 7>&2 2>&4
12a29b1a
TR
730
731# test_cmp is a helper function to compare actual and expected output.
732# You can use it like:
733#
734# test_expect_success 'foo works' '
735# echo expected >expected &&
736# foo >actual &&
737# test_cmp expected actual
738# '
739#
740# This could be written as either "cmp" or "diff -u", but:
741# - cmp's output is not nearly as easy to read as diff -u
742# - not all diff versions understand "-u"
743
744test_cmp() {
745 $GIT_TEST_CMP "$@"
746}
747
b93e6e36
SK
748# test_cmp_bin - helper to compare binary files
749
750test_cmp_bin() {
751 cmp "$@"
752}
753
0f59128f
SG
754# Use this instead of test_cmp to compare files that contain expected and
755# actual output from git commands that can be translated. When running
756# under GETTEXT_POISON this pretends that the command produced expected
757# results.
758test_i18ncmp () {
759 test -n "$GETTEXT_POISON" || test_cmp "$@"
760}
761
762# Use this instead of "grep expected-string actual" to see if the
763# output from a git command that can be translated either contains an
764# expected string, or does not contain an unwanted one. When running
765# under GETTEXT_POISON this pretends that the command produced expected
766# results.
767test_i18ngrep () {
fd29d7b9
SG
768 eval "last_arg=\${$#}"
769
770 test -f "$last_arg" ||
771 error "bug in the test script: test_i18ngrep requires a file" \
772 "to read as the last parameter"
773
774 if test $# -lt 2 ||
775 { test "x!" = "x$1" && test $# -lt 3 ; }
776 then
777 error "bug in the test script: too few parameters to test_i18ngrep"
778 fi
779
0f59128f
SG
780 if test -n "$GETTEXT_POISON"
781 then
63b1a175
SG
782 # pretend success
783 return 0
784 fi
785
786 if test "x!" = "x$1"
0f59128f
SG
787 then
788 shift
63b1a175
SG
789 ! grep "$@" && return 0
790
03aa3783 791 echo >&4 "error: '! grep $@' did find a match in:"
0f59128f 792 else
63b1a175
SG
793 grep "$@" && return 0
794
03aa3783 795 echo >&4 "error: 'grep $@' didn't find a match in:"
0f59128f 796 fi
63b1a175
SG
797
798 if test -s "$last_arg"
799 then
03aa3783 800 cat >&4 "$last_arg"
63b1a175 801 else
03aa3783 802 echo >&4 "<File '$last_arg' is empty>"
63b1a175
SG
803 fi
804
805 return 1
0f59128f
SG
806}
807
8ad16524
JK
808# Call any command "$@" but be more verbose about its
809# failure. This is handy for commands like "test" which do
810# not output anything when they fail.
811verbose () {
812 "$@" && return 0
03aa3783 813 echo >&4 "command failed: $(git rev-parse --sq-quote "$@")"
8ad16524
JK
814 return 1
815}
816
ca8d148d
JH
817# Check if the file expected to be empty is indeed empty, and barfs
818# otherwise.
819
820test_must_be_empty () {
9eb23080
SG
821 test_path_is_file "$1" &&
822 if test -s "$1"
ca8d148d
JH
823 then
824 echo "'$1' is not empty, it contains:"
825 cat "$1"
826 return 1
827 fi
828}
829
5d77298d
MZ
830# Tests that its two parameters refer to the same revision
831test_cmp_rev () {
832 git rev-parse --verify "$1" >expect.rev &&
833 git rev-parse --verify "$2" >actual.rev &&
834 test_cmp expect.rev actual.rev
835}
836
55672a39
JH
837# Print a sequence of integers in increasing order, either with
838# two arguments (start and end):
d17cf5f3 839#
55672a39
JH
840# test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
841#
842# or with one argument (end), in which case it starts counting
843# from 1.
d17cf5f3
MK
844
845test_seq () {
846 case $# in
847 1) set 1 "$@" ;;
848 2) ;;
849 *) error "bug in the test script: not 1 or 2 parameters to test_seq" ;;
850 esac
4df43135
JH
851 test_seq_counter__=$1
852 while test "$test_seq_counter__" -le "$2"
853 do
854 echo "$test_seq_counter__"
855 test_seq_counter__=$(( $test_seq_counter__ + 1 ))
856 done
d17cf5f3
MK
857}
858
12a29b1a
TR
859# This function can be used to schedule some commands to be run
860# unconditionally at the end of the test to restore sanity:
861#
862# test_expect_success 'test core.capslock' '
863# git config core.capslock true &&
864# test_when_finished "git config --unset core.capslock" &&
865# hello world
866# '
867#
868# That would be roughly equivalent to
869#
870# test_expect_success 'test core.capslock' '
871# git config core.capslock true &&
872# hello world
873# git config --unset core.capslock
874# '
875#
876# except that the greeting and config --unset must both succeed for
877# the test to pass.
878#
879# Note that under --immediate mode, no clean-up is done to help diagnose
880# what went wrong.
881
882test_when_finished () {
0968f12a
JK
883 # We cannot detect when we are in a subshell in general, but by
884 # doing so on Bash is better than nothing (the test will
885 # silently pass on other shells).
886 test "${BASH_SUBSHELL-0}" = 0 ||
887 error "bug in test script: test_when_finished does nothing in a subshell"
12a29b1a
TR
888 test_cleanup="{ $*
889 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
890}
891
892# Most tests can use the created repository, but some may need to create more.
893# Usage: test_create_repo <directory>
894test_create_repo () {
895 test "$#" = 1 ||
896 error "bug in the test script: not 1 parameter to test-create-repo"
897 repo="$1"
898 mkdir -p "$repo"
899 (
900 cd "$repo" || error "Cannot setup test environment"
901 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
902 error "cannot run git init -- have you built things yet?"
903 mv .git/hooks .git/hooks-disabled
904 ) || exit
905}
9ce415d9
JS
906
907# This function helps on symlink challenged file systems when it is not
908# important that the file system entry is a symbolic link.
909# Use test_ln_s_add instead of "ln -s x y && git add y" to add a
910# symbolic link entry y to the index.
911
912test_ln_s_add () {
913 if test_have_prereq SYMLINKS
914 then
915 ln -s "$1" "$2" &&
916 git update-index --add "$2"
917 else
918 printf '%s' "$1" >"$2" &&
919 ln_s_obj=$(git hash-object -w "$2") &&
817d03e1
JS
920 git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
921 # pick up stat info from the file
922 git update-index "$2"
9ce415d9
JS
923 fi
924}
4d715ac0 925
ac9afcc3
MT
926# This function writes out its parameters, one per line
927test_write_lines () {
928 printf "%s\n" "$@"
929}
930
a0e0ec9f 931perl () {
a5bf824f
SG
932 command "$PERL_PATH" "$@" 2>&7
933} 7>&2 2>&4
a3a9cff0 934
83d842dc
JK
935# Is the value one of the various ways to spell a boolean true/false?
936test_normalize_bool () {
937 git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
938}
939
940# Given a variable $1, normalize the value of it to one of "true",
941# "false", or "auto" and store the result to it.
942#
943# test_tristate GIT_TEST_HTTPD
944#
945# A variable set to an empty string is set to 'false'.
946# A variable set to 'false' or 'auto' keeps its value.
947# Anything else is set to 'true'.
948# An unset variable defaults to 'auto'.
949#
950# The last rule is to allow people to set the variable to an empty
951# string and export it to decline testing the particular feature
952# for versions both before and after this change. We used to treat
953# both unset and empty variable as a signal for "do not test" and
954# took any non-empty string as "please test".
955
956test_tristate () {
957 if eval "test x\"\${$1+isset}\" = xisset"
958 then
959 # explicitly set
960 eval "
961 case \"\$$1\" in
962 '') $1=false ;;
963 auto) ;;
964 *) $1=\$(test_normalize_bool \$$1 || echo true) ;;
965 esac
966 "
967 else
968 eval "$1=auto"
969 fi
970}
971
972# Exit the test suite, either by skipping all remaining tests or by
973# exiting with an error. If "$1" is "auto", we then we assume we were
974# opportunistically trying to set up some tests and we skip. If it is
975# "true", then we report a failure.
976#
977# The error/skip message should be given by $2.
978#
979test_skip_or_die () {
980 case "$1" in
981 auto)
982 skip_all=$2
983 test_done
984 ;;
985 true)
986 error "$2"
987 ;;
988 *)
989 error "BUG: test tristate is '$1' (real error: $2)"
990 esac
991}
992
4d715ac0
JS
993# The following mingw_* functions obey POSIX shell syntax, but are actually
994# bash scripts, and are meant to be used only with bash on Windows.
995
996# A test_cmp function that treats LF and CRLF equal and avoids to fork
997# diff when possible.
998mingw_test_cmp () {
999 # Read text into shell variables and compare them. If the results
1000 # are different, use regular diff to report the difference.
1001 local test_cmp_a= test_cmp_b=
1002
1003 # When text came from stdin (one argument is '-') we must feed it
1004 # to diff.
1005 local stdin_for_diff=
1006
1007 # Since it is difficult to detect the difference between an
1008 # empty input file and a failure to read the files, we go straight
1009 # to diff if one of the inputs is empty.
1010 if test -s "$1" && test -s "$2"
1011 then
1012 # regular case: both files non-empty
1013 mingw_read_file_strip_cr_ test_cmp_a <"$1"
1014 mingw_read_file_strip_cr_ test_cmp_b <"$2"
1015 elif test -s "$1" && test "$2" = -
1016 then
1017 # read 2nd file from stdin
1018 mingw_read_file_strip_cr_ test_cmp_a <"$1"
1019 mingw_read_file_strip_cr_ test_cmp_b
1020 stdin_for_diff='<<<"$test_cmp_b"'
1021 elif test "$1" = - && test -s "$2"
1022 then
1023 # read 1st file from stdin
1024 mingw_read_file_strip_cr_ test_cmp_a
1025 mingw_read_file_strip_cr_ test_cmp_b <"$2"
1026 stdin_for_diff='<<<"$test_cmp_a"'
1027 fi
1028 test -n "$test_cmp_a" &&
1029 test -n "$test_cmp_b" &&
1030 test "$test_cmp_a" = "$test_cmp_b" ||
1031 eval "diff -u \"\$@\" $stdin_for_diff"
1032}
1033
1034# $1 is the name of the shell variable to fill in
1035mingw_read_file_strip_cr_ () {
1036 # Read line-wise using LF as the line separator
1037 # and use IFS to strip CR.
1038 local line
1039 while :
1040 do
1041 if IFS=$'\r' read -r -d $'\n' line
1042 then
1043 # good
1044 line=$line$'\n'
1045 else
1046 # we get here at EOF, but also if the last line
1047 # was not terminated by LF; in the latter case,
1048 # some text was read
1049 if test -z "$line"
1050 then
1051 # EOF, really
1052 break
1053 fi
1054 fi
1055 eval "$1=\$$1\$line"
1056 done
1057}
d2554c72
JK
1058
1059# Like "env FOO=BAR some-program", but run inside a subshell, which means
1060# it also works for shell functions (though those functions cannot impact
1061# the environment outside of the test_env invocation).
1062test_env () {
1063 (
1064 while test $# -gt 0
1065 do
1066 case "$1" in
1067 *=*)
1068 eval "${1%%=*}=\${1#*=}"
1069 eval "export ${1%%=*}"
1070 shift
1071 ;;
1072 *)
a5bf824f 1073 "$@" 2>&7
d2554c72
JK
1074 exit
1075 ;;
1076 esac
1077 done
1078 )
a5bf824f 1079} 7>&2 2>&4
48860819 1080
9b67c994
JK
1081# Returns true if the numeric exit code in "$2" represents the expected signal
1082# in "$1". Signals should be given numerically.
1083test_match_signal () {
1084 if test "$2" = "$((128 + $1))"
1085 then
1086 # POSIX
1087 return 0
1088 elif test "$2" = "$((256 + $1))"
1089 then
1090 # ksh
1091 return 0
1092 fi
1093 return 1
1094}
39cadeec 1095
48860819
JK
1096# Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
1097test_copy_bytes () {
1098 perl -e '
1099 my $len = $ARGV[1];
1100 while ($len > 0) {
1101 my $s;
1102 my $nread = sysread(STDIN, $s, $len);
1103 die "cannot read: $!" unless defined($nread);
f7f6dc34 1104 last unless $nread;
48860819
JK
1105 print $s;
1106 $len -= $nread;
1107 }
1108 ' - "$1"
1109}
de95302a
JK
1110
1111# run "$@" inside a non-git directory
1112nongit () {
1113 test -d non-repo ||
1114 mkdir non-repo ||
1115 return 1
1116
1117 (
1118 GIT_CEILING_DIRECTORIES=$(pwd) &&
1119 export GIT_CEILING_DIRECTORIES &&
1120 cd non-repo &&
a5bf824f 1121 "$@" 2>&7
de95302a 1122 )
a5bf824f 1123} 7>&2 2>&4
4414a150
JK
1124
1125# convert stdin to pktline representation; note that empty input becomes an
1126# empty packet, not a flush packet (for that you can just print 0000 yourself).
1127packetize() {
1128 cat >packetize.tmp &&
1129 len=$(wc -c <packetize.tmp) &&
1130 printf '%04x%s' "$(($len + 4))" &&
1131 cat packetize.tmp &&
1132 rm -f packetize.tmp
1133}
1134
1135# Parse the input as a series of pktlines, writing the result to stdout.
1136# Sideband markers are removed automatically, and the output is routed to
1137# stderr if appropriate.
1138#
1139# NUL bytes are converted to "\\0" for ease of parsing with text tools.
1140depacketize () {
1141 perl -e '
1142 while (read(STDIN, $len, 4) == 4) {
1143 if ($len eq "0000") {
1144 print "FLUSH\n";
1145 } else {
1146 read(STDIN, $buf, hex($len) - 4);
1147 $buf =~ s/\0/\\0/g;
1148 if ($buf =~ s/^[\x2\x3]//) {
1149 print STDERR $buf;
1150 } else {
1151 $buf =~ s/^\x1//;
1152 print $buf;
1153 }
1154 }
1155 }
1156 '
1157}